package com.friday.custody.dao;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.friday.custody.entity.InvestorInfoEntity;
import org.apache.commons.collections.CollectionUtils;
import org.apache.ibatis.annotations.Mapper;

import java.util.List;
import java.util.Set;
import java.util.stream.Collectors;

/**
 * 
 * 
 * @author lyb
 * @email k0051582@gmail.com
 * @date 2022-01-05 14:07:22
 */
@Mapper
public interface InvestorInfoDao extends BaseMapper<InvestorInfoEntity> {


    List<String> queryInvestor(String custName, String identityNo);

    default Set<String> queryUniqueKeyList(List<String> rawUniqueKeyList){
        if (CollectionUtils.isEmpty(rawUniqueKeyList)){
            return null;
        }
        LambdaQueryWrapper<InvestorInfoEntity> queryWrapper = new LambdaQueryWrapper<>();
        queryWrapper.select(InvestorInfoEntity::getUniqueKey).in(InvestorInfoEntity::getUniqueKey, rawUniqueKeyList);
        List<InvestorInfoEntity> entityList = this.selectList(queryWrapper);
        Set<String> result = entityList.stream().map(t -> t.getUniqueKey()).collect(Collectors.toSet());
        return result;
    }

    default int deleteByUniqueKeys(Set<String> uniqueKeySet){
        LambdaQueryWrapper<InvestorInfoEntity> queryWrapper = new LambdaQueryWrapper();
        queryWrapper.in(InvestorInfoEntity::getUniqueKey, uniqueKeySet);
        return delete(queryWrapper);
    }
}
